package sklep.model;

import java.math.BigDecimal;

public class Towar {
	public int SKALA_KWOT = 2;
	
	private final String nazwa;
	private BigDecimal cenaNetto;
	private BigDecimal vat;
	
	public Towar(String nazwa, BigDecimal cenaNetto, BigDecimal vat) {
		super();
		this.nazwa = nazwa;
		this.cenaNetto = cenaNetto;
		this.vat = vat;
	}

	public BigDecimal getCenaNetto() {
		return cenaNetto;
	}

	public void setCenaNetto(BigDecimal cenaNetto) {
		this.cenaNetto = cenaNetto;
	}

	public BigDecimal getVat() {
		return vat;
	}

	public void setVat(BigDecimal vat) {
		this.vat = vat;
	}

	public String getNazwa() {
		return nazwa;
	}

	public BigDecimal getCenaBrutto() {
		return cenaNetto.multiply(BigDecimal.ONE.add(vat)).setScale(SKALA_KWOT);
	}

	public String getOpis() {
		return nazwa + ": cena netto " + cenaNetto + ", cena brutto " + getCenaBrutto();
	}

	void zmienCene(BigDecimal oIle) {
		BigDecimal nowaCena = getCenaNetto().multiply(BigDecimal.ONE.add(oIle)).setScale(SKALA_KWOT);
		setCenaNetto(nowaCena);
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + SKALA_KWOT;
		result = prime * result + ((cenaNetto == null) ? 0 : cenaNetto.hashCode());
		result = prime * result + ((nazwa == null) ? 0 : nazwa.hashCode());
		result = prime * result + ((vat == null) ? 0 : vat.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Towar other = (Towar) obj;
		if (SKALA_KWOT != other.SKALA_KWOT)
			return false;
		if (cenaNetto == null) {
			if (other.cenaNetto != null)
				return false;
		} else if (!cenaNetto.equals(other.cenaNetto))
			return false;
		if (nazwa == null) {
			if (other.nazwa != null)
				return false;
		} else if (!nazwa.equals(other.nazwa))
			return false;
		if (vat == null) {
			if (other.vat != null)
				return false;
		} else if (!vat.equals(other.vat))
			return false;
		return true;
	}

}
